-- name: [CS] \\#00BBFF\\Yumi Martinez Pack
-- description: Yumi from Dream Raider 64 comes to Super Mario 64! Included is her alternate timeline version made for this pack! Model/OC by Frijoles.z64, Voice by NeverKayZat, Legacy Yumi Idle Animation by steven3004 and Power Meter textures by Inky. [V1.0] 

local TEXT_MOD_NAME = "Yumi Martinez Pack"

-- Stops mod from loading if Character Select isn't on
if not charSelect then
    return djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end

local E_MODEL_YUMI = smlua_model_util_get_id("yumi_geo")
local E_MODEL_YUMI_OLD = smlua_model_util_get_id("yumi_old_geo")

local TEX_YUMI = get_texture_info("yumi_icon")
local TEX_YUMI_OLD = get_texture_info("yumi_old_icon")
local TEX_CUSTOM_DR_STAR_ICON = get_texture_info("dr_star") -- Located in "textures"

-- All Located in "sound"
local VOICETABLE_YUMI = {
    [CHAR_SOUND_ATTACKED] = 'yumi_attacked_new.ogg',
    [CHAR_SOUND_DOH] = 'yumi_doh_new.ogg',
    [CHAR_SOUND_DROWNING] = 'yumi_drowning_new.ogg',
    [CHAR_SOUND_DYING] = 'yumi_dying_new.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'yumi_wah2_new.ogg',
    [CHAR_SOUND_HAHA] = 'yumi_haha_new.ogg',
    [CHAR_SOUND_HAHA_2] = 'yumi_haha_new.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'yumi_here_we_go_new.ogg',
    [CHAR_SOUND_HOOHOO] = 'yumi_hoohoo_new.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'yumi_mama_mia_new.ogg',
--    [CHAR_SOUND_OKEY_DOKEY] = 'yumi_okey_dokey_new.ogg',
    [CHAR_SOUND_ON_FIRE] = 'yumi_on_fire_new.ogg',
    [CHAR_SOUND_OOOF] = 'yumi_oof_new.ogg',
    [CHAR_SOUND_OOOF2] = 'yumi_oof_new.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'yumi_hoo_new.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'yumi_wah_new.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'yumi_yah_new.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'yumi_so_long_bowser_new.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'yumi_weee_new.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'yumi_waaoow_new.ogg',
    [CHAR_SOUND_WAH2] = 'yumi_wah2_new.ogg',
    [CHAR_SOUND_WHOA] = 'yumi_whoa_new.ogg',
    [CHAR_SOUND_YAHOO] = 'yumi_yahoo_new.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'yumi_yahoo_new.ogg', 'yumi_haha_new.ogg', 'yumi_yah_new.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'yumi_yah_new.ogg', 'yumi_wah_new.ogg', 'yumi_hoo_new.ogg'},
    [CHAR_SOUND_YAWNING] = 'yumi_yawn_new.ogg',
    [CHAR_SOUND_SNORING1] = 'yumi_snoring_1_new.ogg',
    [CHAR_SOUND_SNORING2] = 'yumi_snoring_2_new.ogg',
    [CHAR_SOUND_SNORING3] = 'yumi_snoring_3_new.ogg',
    [CHAR_SOUND_COUGHING1] = 'yumi_coughing_new.ogg',
    [CHAR_SOUND_COUGHING2] = 'yumi_coughing_new.ogg',
    [CHAR_SOUND_COUGHING3] = 'yumi_coughing_new.ogg',
    [CHAR_SOUND_PANTING] = 'yumi_pant_new.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'yumi_pant_new.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'yumi_letsago_new.ogg',
    [CHAR_SOUND_EEUH] = 'yumi_eeuh_new.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'yumi_imma_tired_new.ogg',
    [CHAR_SOUND_UH] = 'yumi_uh_new.ogg',
    [CHAR_SOUND_UH2] = 'yumi_uh2_new.ogg',
    [CHAR_SOUND_UH2_2] = 'yumi_uh2_new.ogg',
    [CHAR_SOUND_HRMM] = 'yumi_hrmm_new.ogg',
}

local VOICETABLE_YUMI_OLD = {
    [CHAR_SOUND_ATTACKED] = 'yumi_ow_old.ogg',
    [CHAR_SOUND_DOH] = 'yumi_doh_new.ogg',
    [CHAR_SOUND_DROWNING] = 'yumi_drowning_new.ogg',
    [CHAR_SOUND_DYING] = 'yumi_dying_old.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'yumi_wah2_new.ogg',
    [CHAR_SOUND_HAHA] = 'yumi_yeah_old.ogg',
    [CHAR_SOUND_HAHA_2] = 'yumi_yeah_old.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'yumi_okay_old.ogg',
    [CHAR_SOUND_HOOHOO] = 'yumi_hoohoo_new.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'yumi_owie_old.ogg',
--    [CHAR_SOUND_OKEY_DOKEY] = 'yumi_okey_dokey_new.ogg',
    [CHAR_SOUND_ON_FIRE] = 'yumi_on_fire_old.ogg',
    [CHAR_SOUND_OOOF] = 'yumi_oof_new.ogg',
    [CHAR_SOUND_OOOF2] = 'yumi_oof_new.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'yumi_hoo_new.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'yumi_wah_new.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'yumi_yah_new.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'yumi_byebye_old.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'yumi_weee_new.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'yumi_waaoow_old.ogg',
    [CHAR_SOUND_WAH2] = 'yumi_wah2_new.ogg',
    [CHAR_SOUND_WHOA] = 'yumi_whoa_new.ogg',
    [CHAR_SOUND_YAHOO] = 'yumi_yahoo_old.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'yumi_yahoo_old.ogg', 'yumi_haha_new.ogg', 'yumi_yah_new.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'yumi_yah_new.ogg', 'yumi_wah_new.ogg', 'yumi_hoo_new.ogg'},
    [CHAR_SOUND_YAWNING] = 'yumi_yawn_old.ogg',
    [CHAR_SOUND_SNORING1] = 'yumi_snoring_1_new.ogg',
    [CHAR_SOUND_SNORING2] = 'yumi_snoring_2_new.ogg',
    [CHAR_SOUND_SNORING3] = 'yumi_snoring_3_new.ogg',
    [CHAR_SOUND_COUGHING1] = 'yumi_coughing_new.ogg',
    [CHAR_SOUND_COUGHING2] = 'yumi_coughing_new.ogg',
    [CHAR_SOUND_COUGHING3] = 'yumi_coughing_new.ogg',
    [CHAR_SOUND_PANTING] = 'yumi_pant_new.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'yumi_pant_new.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'yumi_letsago_new.ogg',
    [CHAR_SOUND_EEUH] = 'yumi_eeuh_new.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'yumi_imma_tired_new.ogg',
    [CHAR_SOUND_UH] = 'yumi_uh_new.ogg',
    [CHAR_SOUND_UH2] = 'yumi_uh2_new.ogg',
    [CHAR_SOUND_UH2_2] = 'yumi_uh2_new.ogg',
    [CHAR_SOUND_HRMM] = 'yumi_hrmm_new.ogg',
}


-- Animation Tables

local ANIMTABLE_YUMI = {
    [MARIO_ANIM_IDLE_HEAD_LEFT] = "yumi_left",
    [MARIO_ANIM_IDLE_HEAD_RIGHT] = "yumi_right",
    [MARIO_ANIM_IDLE_HEAD_CENTER] = "yumi_center",
--    [MARIO_ANIM_TAKE_CAP_OFF_THEN_ON] = "yumi_painting_clear",
    [MARIO_ANIM_FIRST_PERSON] = "yumi_idle_first_person_new"
}
local ANIMTABLE_YUMI_OLD = {
    [MARIO_ANIM_IDLE_HEAD_LEFT] = "yumi_idle_old",
    [MARIO_ANIM_IDLE_HEAD_RIGHT] = "yumi_idle_old",
    [MARIO_ANIM_IDLE_HEAD_CENTER] = "yumi_idle_old",
    [MARIO_ANIM_FIRST_PERSON] = "yumi_idle_old"

}   

local animTables = {}

---@param charType integer
---@param animTable table
---@return table
function character_add_anim_table(charType, animTable)
    animTables[charType] = animTable
    return animTable
end

-- All Located in "actors"
local CAPTABLE_YUMI = {
    normal = smlua_model_util_get_id("yumi_cap_normal_geo"),
    wing = smlua_model_util_get_id("yumi_cap_wing_geo"),
    metal = smlua_model_util_get_id("yumi_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("yumi_cap_wing_geo"),
}

local CAPTABLE_YUMI_OLD = {
    normal = smlua_model_util_get_id("yumi_old_model_cap_normal_geo"),
    wing = smlua_model_util_get_id("yumi_old_cap_wing_geo"),
    metal = smlua_model_util_get_id("yumi_old_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("yumi_old_cap_wing_geo"),
}

local E_MODEL_DR_STAR = smlua_model_util_get_id("dr_star_geo") -- Located in "actors"

local PALETTE_CHAR = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ffffff",
    [HAIR]   = "ffffff",
    [SKIN]   = "ffffff",
    [CAP]    = "ffffff",
}


-- All Located in "textures"
local HEALTH_METER_YUMI = {
    
    label = {
        left = get_texture_info("power_left"),
        right = get_texture_info("power_right"),
    },
    pie = {
        [1] = get_texture_info("power_1"),
        [2] = get_texture_info("power_2"),
        [3] = get_texture_info("power_3"),
        [4] = get_texture_info("power_4"),
        [5] = get_texture_info("power_5"),
        [6] = get_texture_info("power_6"),
        [7] = get_texture_info("power_7"),
        [8] = get_texture_info("power_8"),
    }
}


local HEALTH_METER_YUMI_OLD = {
    
    label = {
        left = get_texture_info("pow_left"),
        right = get_texture_info("pow_right"),
    },
    pie = {
        [1] = get_texture_info("pow_1"),
        [2] = get_texture_info("pow_2"),
        [3] = get_texture_info("pow_3"),
        [4] = get_texture_info("pow_4"),
        [5] = get_texture_info("pow_5"),
        [6] = get_texture_info("pow_6"),
        [7] = get_texture_info("pow_7"),
        [8] = get_texture_info("pow_8"),
    }
}


--[[
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

CT_YUMI = charSelect.character_add("Yumi Martinez", {"A college student with a mild temper.", "She doesn't know why she's here.", "Maybe it's a dream?"}, "Model/OC by Frijoles.z64, Voice by NeverKayZat", {r = 90, g = 90, b = 220}, E_MODEL_YUMI, CT_LUIGI, TEX_YUMI)
charSelect.character_add_caps(E_MODEL_YUMI, CAPTABLE_YUMI)
charSelect.character_add_voice(E_MODEL_YUMI, VOICETABLE_YUMI)
CT_YUMI_OLD = charSelect.character_add("Legacy Yumi", {"Yumi from another timeline.", "She's more cheerful than", "her brown haired sister."}, "Model/OC by Frijoles.z64, Voice by NeverKayZat, Idle Animation by steven3004.", {r = 9, g = 75, b = 181}, E_MODEL_YUMI_OLD, CT_LUIGI, TEX_YUMI_OLD)
--charSelect.character_add_caps(E_MODEL_YUMI_OLD, CAPTABLE_YUMI_OLD)
charSelect.character_add_voice(E_MODEL_YUMI_OLD, VOICETABLE_YUMI_OLD)
character_add_anim_table(CT_YUMI, ANIMTABLE_YUMI)
character_add_anim_table(CT_YUMI_OLD, ANIMTABLE_YUMI_OLD)
_G.charSelect.character_add_health_meter(CT_YUMI, HEALTH_METER_YUMI)
_G.charSelect.character_add_health_meter(CT_YUMI_OLD, HEALTH_METER_YUMI_OLD)
_G.charSelect.character_add_celebration_star(E_MODEL_YUMI, E_MODEL_DR_STAR, TEX_CUSTOM_DR_STAR_ICON)
_G.charSelect.character_add_celebration_star(E_MODEL_YUMI_OLD, E_MODEL_DR_STAR, TEX_CUSTOM_DR_STAR_ICON)

local function on_character_sound(m, sound)
    if charSelect.character_get_voice(m) == VOICETABLE_YUMI then return charSelect.voice.sound(m, sound) end
    if charSelect.character_get_voice(m) == VOICETABLE_YUMI_OLD then return charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if charSelect.character_get_voice(m) == VOICETABLE_YUMI then return charSelect.voice.snore(m) end
    if charSelect.character_get_voice(m) == VOICETABLE_YUMI_OLD then return charSelect.voice.snore(m) end
end

local function character_animation(m)
    p = gPlayerSyncTable[m.playerIndex]
    sP = gPlayerSyncTable[0]
    sP.characterType = charSelect.character_get_current_number()
    local curAnimId = m.marioObj.header.gfx.animInfo.animID
    if animTables[p.characterType] ~= nil then
        if animTables[p.characterType][curAnimId] ~= nil then
            smlua_anim_util_set_animation(m.marioObj, animTables[p.characterType][curAnimId])
        end
    end
end

YUMI_EYES_HURT = 9
local function yumi_eyes(m)
    if p.characterType ~= CT_YUMI then return end

    local eyeStateTable = {
        [MARIO_ANIM_IDLE_HEAD_LEFT] = MARIO_EYES_LOOK_LEFT,
        [MARIO_ANIM_IDLE_HEAD_RIGHT] = MARIO_EYES_LOOK_RIGHT
    }

    if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_TAKE_CAP_OFF_THEN_ON then
    smlua_anim_util_set_animation(m.marioObj, "yumi_painting_clear")
    m.marioBodyState.handState = MARIO_HAND_FISTS
    m.marioBodyState.capState = 0
    if m.marioObj.header.gfx.animInfo.animFrame < 90 then
        m.marioBodyState.eyeState = 10
    elseif m.marioObj.header.gfx.animInfo.animFrame < 120 then
        m.marioBodyState.eyeState = MARIO_EYES_OPEN
    end
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_ELECTROCUTION then
    m.marioBodyState.eyeState = YUMI_EYES_HURT
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SHOCKED then
    m.marioBodyState.eyeState = YUMI_EYES_HURT
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_FIRE_LAVA_BURN then
    m.marioBodyState.eyeState = YUMI_EYES_HURT
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SOFT_BACK_KB then
    m.marioBodyState.eyeState = YUMI_EYES_HURT
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SOFT_FRONT_KB then
    m.marioBodyState.eyeState = YUMI_EYES_HURT
end

    local curAnimId = m.marioObj.header.gfx.animInfo.animID

    if eyeStateTable[curAnimId] ~= nil then
        m.marioBodyState.eyeState = eyeStateTable[curAnimId]
    end
end



YUMI_OLD_EYES_HURT = 9
YUMI_OLD_EYES_YAWN = 10
YUMI_OLD_EYES_WINK = 11
local function yumi_old_eyes(m)
    if p.characterType ~= CT_YUMI_OLD then return end

    local eyeStateTable = {
        [MARIO_ANIM_IDLE_HEAD_LEFT] = MARIO_EYES_LOOK_LEFT,
        [MARIO_ANIM_IDLE_HEAD_RIGHT] = MARIO_EYES_LOOK_RIGHT
    }

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_IDLE_HEAD_LEFT then
    m.marioBodyState.handState = MARIO_HAND_OPEN
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_IDLE_HEAD_RIGHT then
    m.marioBodyState.handState = MARIO_HAND_OPEN
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_IDLE_HEAD_CENTER then
    m.marioBodyState.handState = MARIO_HAND_OPEN
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_FIRST_PERSON then
    m.marioBodyState.handState = MARIO_HAND_OPEN
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_ELECTROCUTION then
    m.marioBodyState.eyeState = YUMI_OLD_EYES_HURT
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SHOCKED then
    m.marioBodyState.eyeState = YUMI_OLD_EYES_HURT
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_FIRE_LAVA_BURN then
    m.marioBodyState.eyeState = YUMI_OLD_EYES_HURT
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SOFT_BACK_KB then
    m.marioBodyState.eyeState = YUMI_OLD_EYES_HURT
end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_SOFT_FRONT_KB then
    m.marioBodyState.eyeState = YUMI_OLD_EYES_HURT
end

--if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_START_SLEEP_YAWN then
--    m.marioBodyState.eyeState = YUMI_OLD_YAWN
--end

if m.marioObj.header.gfx.animInfo.animID == MARIO_ANIM_STAR_DANCE then
        m.marioBodyState.eyeState = YUMI_OLD_EYES_WINK
end
    
    local curAnimId = m.marioObj.header.gfx.animInfo.animID

    if eyeStateTable[curAnimId] ~= nil then
        m.marioBodyState.eyeState = eyeStateTable[curAnimId]
    end
end


hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)
hook_event(HOOK_MARIO_UPDATE, character_animation)
hook_event(HOOK_MARIO_UPDATE, yumi_eyes)
hook_event(HOOK_MARIO_UPDATE, yumi_old_eyes)